'$INCLUDE: 'c:\qb45\library\GUISER.BI'

'================================================================
' year 2005   GRAPHICAL USER INTERFACE - TEXT MODE - Qbasic
'================================================================
'Mouse routine was downloaded from internet, is the WMOUSE.BAS
'all the rest was written by me, Sergio: develop05wanadoo.es


'STYLES OF GUI: "standard", ",cyan","blue", "dark"

DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B
DATA 5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F
DATA 8B,5E,06,89,17,5D,CA,08,00

SUB APP.Style (Style$)

MouseDriver 1, bx%, cx%, dx%, lb%, rb%, 1


SELECT CASE Style$

CASE "standard"
c1 = 15 'bright white  (foreground)
c2 = 7  'gray  (background)
c3 = 0  'black  (shadow of button)
c4 = 7
c1r = 0
c2r = 7
c3r = 15
c4r = 0

foreg = 1
backg = 15

CASE "cyan"
c1 = 15
c2 = 3
c3 = 0
c4 = 3
c1r = 0
c2r = 3
c3r = 15
c4r = 0

foreg = 15
backg = 1

CASE "blue"
c1 = 15
c2 = 9
c3 = 0
c4 = 9
c1r = 0
c2r = 1
c3r = 15
c4r = 0

foreg = 15
backg = 0


CASE "dark"
c1 = 15
c2 = 7
c3 = 0
c4 = 7
c1r = 0
c2r = 7
c3r = 15
c4r = 0
foreg = 15
backg = 0


END SELECT

cl1 = c1
cl2 = c2
cl3 = c3
cl4 = c4
CLS 0
COLOR foreg, backg
CLS 0

cy = 3 'coord Y menu a tendina

LOCATE 1, 1
COLOR backg, foreg
PRINT STRING$(80, CHR$(32))

END SUB

SUB button (n, x1b, y1b, x2b, y2b, label$)

COLOR cl1, cl2
IF x1b < 1 THEN x1b = 1
IF x2b < 1 THEN x2b = 1
IF y1b < 1 THEN y1b = 1
IF y2b < 1 THEN y2b = 1


'parametri da restituire al modulo principale

bt(n) = n
xx1b(n) = x1b
yy1b(n) = y1b
xx2b(n) = x2b
yy2b(n) = y2b
llabel$(n) = label$

'disegno del bottone

LOCATE y1b, x1b
PRINT CHR$(218) + STRING$((x2b - x1b), CHR$(196));
COLOR cl3, cl2
PRINT CHR$(191)

FOR jb = y1b TO (y2b - 3)
LOCATE yb + 1 + jb, x1b
COLOR cl1, cl2
PRINT CHR$(179);
'COLOR cl4, cl1
COLOR cl1, cl2
PRINT STRING$((x2b - x1b), " ");

COLOR cl3, cl2
PRINT CHR$(179)
NEXT
COLOR cl1, cl2
LOCATE jb, x1b
PRINT CHR$(192);
COLOR cl3, cl2
PRINT STRING$((x2b - x1b), CHR$(196)) + CHR$(217)
COLOR cl3, cl4
LOCATE y1b + INT(y2b - y1b) / 2 - 1, x1b + (INT(x2b - x1b) / 2) - (LEN(label$) / 3): PRINT label$

END SUB

SUB cleanscreen
FOR J = 1 TO 25
FOR K = 1 TO 80
'PRINT cl(J, K)
IF cl(J, K) = 112 THEN COLOR 0, 15
IF cl(J, K) = 127 THEN COLOR 15, 15
IF cl(J, K) = 31 THEN COLOR 15, 1
IF cl(J, K) = 16 THEN COLOR 0, 1
IF cl(J, K) = 113 THEN COLOR 0, 15
IF cl(J, K) = 15 THEN COLOR 15, 0
IF cl(J, K) = 63 THEN COLOR 15, 3
IF cl(J, K) = 48 THEN COLOR 0, 3
LOCATE J, K: PRINT char$(J, K)
NEXT
NEXT
COLOR backg, foreg
END SUB

SUB drawmenu (Menu, MaxMenu)
' Calcolo della label di menu piu lunga
DIM m(100)
DIM K(20)
FOR K = 1 TO 20
m(K) = LEN(MenuItem$(K, Menu))
NEXT
K = K - 1
FOR l% = K TO 2 STEP -1
FOR i% = 1 TO l% - 1
IF m(i% + 1) < m(i%) THEN SWAP m(i% + 1), m(i%)
NEXT i%
NEXT l%
lm = m(20)
IF lm < 8 THEN lm = 8

'disegno del menu a tendina


LOCATE 2, posit(Menu)

PRINT CHR$(218) + STRING$(lm + 2, CHR$(196)) + CHR$(191)

h = 2
cym = 0

FOR K = 1 TO 20
IF MenuItem$(K, Menu) <> "" THEN
h = h + 1
cym = cym + 1
LOCATE h, posit(Menu)
PRINT CHR$(179) + STRING$(lm + 2, CHR$(32)) + CHR$(179)
LOCATE h, posit(Menu) + 2
PRINT MenuItem$(K, Menu)
END IF
NEXT
LOCATE h + 1, posit(Menu)
PRINT CHR$(192) + STRING$(lm + 2, CHR$(196)) + CHR$(217)


cx = posit(Menu)

END SUB

SUB GUIENGINE

'===============================================
'            START THE MOUSE ROUTINE
'===============================================

DO 'loop of mouse routine

COLOR cl3, cl2
MouseDriver 3, bx%, cx%, dx%, lb%, rb%, 0
LOCATE 49, 1: PRINT "Lb%="; lb%; "Rb%="; rb%; "X="; cx%; "Y="; dx%;

'===============================================
'         MOUSE: MENU NAVIGATION
'===============================================

IF rb% = -1 THEN     'right button
MenuOn = 0   'turn off then pop up menu

cleanscreen

END IF

IF lb% = -1 AND dx% = 0 THEN   'left button

MenuOn = 1

'============= MOVING BEETWEEN MENU AND ACTIVATE =============

FOR J = 1 TO MaxMenu

IF posit(J - 1) <= INT(cx% / 7) AND INT(cx% / 7) < posit(J) THEN

u = J - 1
GOTO PopUp:
END IF
NEXT

PopUp:
IF posit(MaxMenu) <= INT(cx% / 7) THEN u = MaxMenu
IF posit(u) <= 0 THEN u = 1
cleanscreen
drawmenu u, MaxMenu
END IF

'========== MOVING UP AND DOWN IN THE CURRENT MENU ============

IF MenuOn = 1 AND INT(dx% / 7) > 2 THEN
              cy = INT(dx% / 7)
              IF cy < 3 THEN cy = 3
              IF cy >= cym + 2 THEN cy = cym + 2
             
              FOR i = cx + 1 TO (cx + lm + 2)
              COLOR foreg, backg
              LOCATE cy, i: PRINT CHR$(SCREEN(cy, i))
              COLOR backg, foreg
              LOCATE cy - 1, i: PRINT CHR$(SCREEN(cy - 1, i))
              LOCATE cy + 1, i: PRINT CHR$(SCREEN(cy + 1, i))
              NEXT
 
'=============================================================
'           INSERT HERE YOUR EVENTS BY MENU
'=============================================================

IF lb% = -1 THEN    'if the left mouse button is clicked

MenuSys.Menu = u
MenuSys.option = cy - 2
MenuOn = 1
EXIT SUB

END IF
END IF


'===========================================
'             BUTTONS CLICKED
'===========================================

'J = maximum number of buttons
FOR J = 1 TO 50
IF MenuOn = 0 THEN
IF cx% <> 0 AND dx% <> 0 THEN
IF lb% = -1 AND cx% >= xx1b(J) * 8 AND cx% <= xx2b(J) * 8 AND dx% >= yy1b(J) * 8 AND dx% <= yy2b(J) * 8 THEN


'draw the button on

cl1 = c1r
cl2 = c2r
cl3 = c3r
cl4 = c4r

button bt(J), xx1b(J), yy1b(J), xx2b(J), yy2b(J), llabel$(J)

FOR ritardo = 1 TO 10500
NEXT

cl1 = c1
cl2 = c2
cl3 = c3
cl4 = c4


'draw the button off

button bt(J), xx1b(J), yy1b(J), xx2b(J), yy2b(J), llabel$(J)

Button.Click = J

EXIT SUB

END IF
END IF    'END OF CONDITION (IF THE LEFT BUTTON IS CLICK)
END IF
NEXT

'===================================================
'              KEYBOARD EVENT HANDLER
'===================================================

MENUHANDLER:
REDIM a1$(100)
in$ = UCASE$(INKEY$)
SELECT CASE in$
  
   CASE CHR$(27)
   END
    CASE CHR$(0) + ";"  'F1
        MenuOn = 0
        MenuPos = 1
      
                    'FOR i = 2 TO 13
                    'COLOR 0, 0
                    'LOCATE i, 1
                    'PRINT SPACE$(80)
                    'NEXT
      
       
        COLOR backg, foreg
        drawmenu MenuPos, MaxMenu
            
              CASE CHR$(0) + "M"' cursor right
              MenuOn = 0
              cy = 3
              MenuPos = MenuPos + 1
              IF MenuPos > MaxMenu THEN MenuPos = 1
              cleanscreen
             
              drawmenu MenuPos, MaxMenu
                  
                    CASE CHR$(0) + "K"  ' cursor left
                    MenuOn = 0
                    cy = 3
                    MenuPos = MenuPos - 1
                             
                    IF MenuPos <= 0 THEN MenuPos = MaxMenu
                    cleanscreen
                    drawmenu MenuPos, MaxMenu

              CASE CHR$(0) + "P"    'cusor down
              MenuOn = 0
              FOR i = cx + 1 TO (cx + lm + 2)
              COLOR backg, foreg
              LOCATE cym + 2, i: PRINT CHR$(SCREEN(cym + 2, i))
              COLOR foreg, backg
              LOCATE cy, i: PRINT CHR$(SCREEN(cy, i))
             
              a1$(i) = CHR$(SCREEN(cy, i))
              a1$(i) = a1$(i - 1) + a1$(i)
              b$ = a1$(i)
            
              COLOR backg, foreg
              LOCATE cy - 1, i: PRINT CHR$(SCREEN(cy - 1, i))
              NEXT
              cy = cy + 1
              MenuSys.Menu = MenuPos
              MenuSys.option = cy - 3
              IF cy > cym + 2 THEN
              COLOR foreg, backg
              FOR i = cx + 1 TO (cx + lm)
              LOCATE cym + 2, i: PRINT CHR$(SCREEN(cym + 2, i))
              cy = 3
              NEXT
              END IF
            
            
              CASE CHR$(0) + "H"    'cusor up
              MenuOn = 0
              cy = cy - 1
              MenuSys.Menu = MenuPos
              MenuSys.option = cy - 2
              IF cy < 3 THEN cy = cym + 2
            
              FOR i = cx + 1 TO (cx + lm + 2)
              COLOR backg, foreg
            
              LOCATE 3, i: PRINT CHR$(SCREEN(3, i))
              NEXT
              FOR i = cx + 1 TO (cx + lm + 2)
              COLOR foreg, backg
              LOCATE cy, i: PRINT CHR$(SCREEN(cy, i))
             
              a1$(i) = CHR$(SCREEN(cy, i))
              a1$(i) = a1$(i - 1) + a1$(i)
              b$ = a1$(i)

              COLOR backg, foreg
              LOCATE cy + 1, i: PRINT CHR$(SCREEN(cy + 1, i))
              NEXT

CASE CHR$(13)
MenuOn = 1
EXIT SUB

END SELECT



fin:
                
'IF INKEY$ = CHR$(27) THEN END

LOOP 'loop of mouse routine

END SUB

SUB Menu.AddOption (item, Menu, ItemCaption$)
REDIM ItemCaption$(20, 20)
MenuItem$(item, Menu) = ItemCaption$

END SUB

SUB Menu.Create (Menu, max, MenuCaption$)

MaxMenu = max
MenT$(Menu) = MenuCaption$

SELECT CASE Menu

CASE 1
posit(Menu) = 1

CASE ELSE
DIM p(100)
FOR J = 1 TO Menu - 1
p(J) = LEN(MenT$(J)) + 2
p(J) = p(J - 1) + p(J)
pp = p(J)
posit(Menu) = pp
NEXT

END SELECT

COLOR backg, foreg

LOCATE 1, posit(Menu)
PRINT MenuCaption$
END SUB

SUB MouseDriver (AX%, bx%, cx%, dx%, lb%, rb%, EX%)
IF EX% = 1 THEN
mouse$ = SPACE$(57)
FOR i% = 1 TO 57
READ a$
h$ = CHR$(VAL("&H" + a$))
MID$(mouse$, i%, 1) = h$
NEXT i%




CLS
END IF
DEF SEG = VARSEG(mouse$)
CALL Absolute(AX%, bx%, cx%, dx%, SADD(mouse$))
lb% = ((bx% AND 1) <> 0)
rb% = ((bx% AND 2) <> 0)
END SUB

SUB MsgBox (xc, yc, Mlabel$)

COLOR cl1, cl2

x1m = xc - ((LEN(Mlabel$)) / 2) - 1
x2m = xc + ((LEN(Mlabel$)) / 2) + 1
y1m = yc - 3
y2m = yc + 3

IF x1m <= 1 THEN x1m = 1
IF x2m <= 1 THEN x2m = 5
IF y1m <= 1 THEN y1m = 5
IF y2m <= 1 THEN y2m = 10

'disegno del message box

LOCATE y1m, x1m
PRINT CHR$(201) + STRING$((x2m - x1m), CHR$(205));
COLOR cl3, cl2
PRINT CHR$(187)

FOR jb = y1m TO (y2m - 3)
LOCATE yb + 1 + jb, x1m
COLOR cl1, cl2
PRINT CHR$(186);
'COLOR cl4, cl1
COLOR cl1, cl2
PRINT STRING$((x2m - x1m), " ");

COLOR cl3, cl2
PRINT CHR$(186)
NEXT
COLOR cl1, cl2
LOCATE jb, x1m
PRINT CHR$(200);
COLOR cl3, cl2
PRINT STRING$((x2m - x1m), CHR$(205)) + CHR$(188)
COLOR cl3, cl4
LOCATE yc - 1, xc - LEN(Mlabel$) / 2 + 1
PRINT Mlabel$
END SUB

SUB Panel (n, x1b, y1b, x2b, y2b)

COLOR cl1, cl2
IF x1b < 1 THEN x1b = 1
IF x2b < 1 THEN x2b = 1
IF y1b < 1 THEN y1b = 1
IF y2b < 1 THEN y2b = 1


'disegno del pannello

LOCATE y1b, x1b
PRINT CHR$(201) + STRING$((x2b - x1b), CHR$(205));
COLOR cl3, cl2
PRINT CHR$(187)

FOR jb = y1b TO (y2b - 3)
LOCATE yb + 1 + jb, x1b
COLOR cl1, cl2
PRINT CHR$(186);
'COLOR cl4, cl1
COLOR cl1, cl2
PRINT STRING$((x2b - x1b), " ");

COLOR cl3, cl2
PRINT CHR$(186)
NEXT
COLOR cl1, cl2
LOCATE jb, x1b
PRINT CHR$(200);
COLOR cl3, cl2
PRINT STRING$((x2b - x1b), CHR$(205)) + CHR$(188)
COLOR cl3, cl4

END SUB

SUB SCANSCR
FOR J = 2 TO 25
FOR K = 1 TO 80
char$(J, K) = CHR$(SCREEN(J, K))
cl(J, K) = SCREEN(J, K, 1)
NEXT
NEXT
page = 1

END SUB

SUB TextBox (b#, x1t, y1t, LenField%, RowField%)
nu = b#
rf(nu) = RowField%
x2t = x1t + LenField% + 1
y2t = y1t + RowField% + 1

cc1 = c1r
cc2 = c2r
cc3 = c3r
cc4 = c4r

'disegno del textbox
COLOR cc1, cc2

LOCATE y1t, x1t
PRINT CHR$(218) + STRING$((x2t - x1t), CHR$(196));
COLOR cc1, cc2
PRINT CHR$(191)

FOR jb = y1t + 1 TO (y2t) - 1
LOCATE jb, x1t
COLOR cc1, cc2
PRINT CHR$(179);
'COLOR cc4, cc1
COLOR cc1, cc2
PRINT STRING$((x2t - x1t), " ");

COLOR cc3, cc2
PRINT CHR$(179)
NEXT
COLOR cc1, cc2
LOCATE jb, x1t
PRINT CHR$(192);
COLOR cc3, cc2
PRINT STRING$((x2t - x1t), CHR$(196)) + CHR$(217)
COLOR cc3, cc4

yys(nu) = y1t + 1            'margine superiore del campo editabile
yyi(nu) = y2t - 1           'margine inferiore del campo editabile
ssx(nu) = x1t + 1            'margine sinistro del campo editabile
ddx(nu) = x2t - 1     'margine destro del campo editabile
ppy(nu) = yys(nu)           'Y iniziale del cursore
ppx(nu) = ssx(nu)           'X iniziale del cursore


END SUB

SUB TextBox.Edit (b#)
nu = b#
ys = yys(nu)
yi = yyi(nu)
sx = ssx(nu)
dx = ddx(nu)
py = ppy(nu)
px = ppx(nu)


cc1 = c1r
cc2 = c2r
cc3 = c3r
cc4 = c4r

ingresso:
LOCATE py, px
COLOR cc1 + 16
PRINT "_"
vai:
d$ = INKEY$

' -------- BARRA SPAZIATRICE ---------
IF d$ = CHR$(32) THEN
LOCATE py, px
COLOR cc2, cc2
PRINT " "
IF px < dx THEN px = px + 1
IF px < dx THEN LOCATE py, px - 1: PRINT CHR$(SCREEN(py, px - 1))
IF px < dx THEN LOCATE py, px: PRINT CHR$(SCREEN(py, px))
LOCATE py, px + 1: PRINT CHR$(SCREEN(py, px + 1))
END IF

' --------------- CARATTERI ALFANUMERICI ---------------
IF d$ > "0" THEN
'IF CHR$(SCREEN(py, px - 1)) = " " THEN LOCATE py, px - 1: COLOR 15: PRINT " "
LOCATE py, px
'COLOR 31, cc2
PRINT d$

IF px < dx THEN px = px + 1
LOCATE py, px:
COLOR cc1, cc2
PRINT CHR$(SCREEN(py, px))
LOCATE py, px - 1: PRINT CHR$(SCREEN(py, px - 1))
END IF

'simboli di punteggiatura
IF d$ = CHR$(44) OR d$ = CHR$(45) OR d$ = CHR$(46) THEN GOTO segni:
IF d$ = CHR$(39) OR d$ = CHR$(40) OR d$ = CHR$(41) THEN GOTO segni:
IF d$ = CHR$(42) OR d$ = CHR$(43) OR d$ = CHR$(33) THEN GOTO segni:
IF d$ = CHR$(34) OR d$ = CHR$(35) OR d$ = CHR$(36) THEN GOTO segni:
IF d$ = CHR$(37) OR d$ = CHR$(38) OR d$ = CHR$(47) THEN GOTO segni:
IF d$ = CHR$(48) THEN GOTO segni:
GOTO sinistra:

segni:
 LOCATE py, px: COLOR cc1, cc3: PRINT d$
 'IF CHR$(SCREEN(py, px - 1)) = " " THEN LOCATE py, px - 1: COLOR a, b: PRINT " "
 IF px < dx THEN px = px + 1
 LOCATE py, px: COLOR 31, cc3
 PRINT CHR$(SCREEN(py, px))


sinistra:
' -------------- FRECCIA A SINISTRA ------------
IF d$ = CHR$(0) + "K" THEN      'sinistra
IF px > sx THEN px = px - 1
l = SCREEN(py, px)
LOCATE py, px: COLOR 31, cc1: PRINT CHR$(l)
m = SCREEN(py, px + 1)
LOCATE py, px + 1: COLOR cc1, cc2: PRINT CHR$(m)
END IF


' -------------- FRECCIA A DESTRA ------------
destra:
IF d$ = CHR$(0) + "M" THEN    'destra
IF px < dx THEN px = px + 1
l = SCREEN(py, px)
LOCATE py, px: COLOR 31, cc1: PRINT CHR$(l)
m = SCREEN(py, px - 1)
LOCATE py, px - 1: COLOR cc1, cc2: PRINT CHR$(m)
END IF

'---------- TASTO BACKDEL - CANCELLA INDIETRO -------

IF d$ = CHR$(8) THEN    'backdel
LOCATE py, px: COLOR cc2, cc2: PRINT " "
IF px > sx THEN
LOCATE py, px - 1: COLOR 31, cc1: PRINT CHR$(SCREEN(py, px - 1))
END IF
IF px > sx THEN px = px - 1
END IF

' -------------- TASTO ESC ---------------

IF d$ = CHR$(27) THEN 'esc
GOTO savefields:
END IF

' ---------- TASTO INVIO - ACCETTAZIONE RECORDS ----------
IF d$ = CHR$(13) THEN  'invio
LOCATE py, px: COLOR cc1, cc2: PRINT CHR$(SCREEN(py, px))
px = sx
IF py < yi THEN py = py + 1
LOCATE py, px: COLOR 31, cc1: PRINT CHR$(SCREEN(py, px))
END IF

' -------------- FRECCIA SU ------------

IF d$ = CHR$(0) + "H" THEN     'su
LOCATE py, px: COLOR cc1, cc2: PRINT CHR$(SCREEN(py, px))
IF py > ys THEN py = py - 1
LOCATE py, px: COLOR 31, cc1: PRINT CHR$(SCREEN(py, px))
END IF

' ------------- FRECCIA GIU' -------------

IF d$ = CHR$(0) + "P" THEN     'gi
LOCATE py, px: COLOR cc1, cc2: PRINT CHR$(SCREEN(py, px))
IF py < yi THEN py = py + 1
LOCATE py, px: COLOR 31, cc1: PRINT CHR$(SCREEN(py, px))
END IF

' -------- TASTO F2 --------
IF d$ = CHR$(0) + "<" THEN
GOTO savefields:
END IF


GOTO vai:


'GOTO ingresso:

savefields:
kk = 1
REDIM TextRows$(rf(nu))
DIM sc$(80)
FOR yc = yys(nu) TO yyi(nu)
FOR xc = ssx(nu) TO ddx(nu)
sc$(xc) = CHR$(SCREEN(yc, xc))
sc$(xc) = sc$(xc - 1) + sc$(xc)
s$ = sc$(xc)
NEXT xc
TextRows$(kk) = s$
kk = kk + 1
NEXT yc

finale:
Button.Click = 0


END SUB

